/**
 * FriendsFinderController.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('controllers/friends/finder/friendsfindercontroller',
		['app',
		 'shared/urlcatalog',
		 'shared/keys',
		 'ember',
		 'models/user/user'],
		 function(Filmeet, UrlCatalog, Keys){
	console.log('Defining FriendsFinderController');
	Filmeet.FriendsFinderController = Ember.ArrayController.extend({
		// Properties
		searchText: null,
		// Functions
		/** Goes to the friends screen */
		goFriendsScreen: function(){
			this.transitionToRoute('friends.directory');
		},
		/** Adds a new friend */
		addFriend: function(selectedUser){
			$.ajax({
				type: 'POST',
				cache: false,
				url: UrlCatalog.get('addFriend'),
				data: {'userSid1': selectedUser.username, 'userSid2': localStorage.getItem(Keys.username), 'hash': localStorage.getItem(Keys.authorizationHash)},
				success: function(){}
			});
			this.get('content').removeObject(selectedUser);
		},
		/** Searches not friends */
		searchNotFriends: function(){
			var self = this;
			var searchedText = self.get('searchText');
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('searchNotFriends'),
				data: {'words': searchedText, 'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: function(data){
					var searchResult = [];
					data.forEach(function(user){
						searchResult.addObject(Filmeet.User.create({
							username: user.username
						}));
					});
					self.set('content', searchResult);
				}
			});
		}.observes('searchText')
	});
});