/**
 * Candidate data model.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */
define('models/candidate/candidate',
		['app',
		 'shared/urlcatalog',
		 'shared/keys',
		 'ember'],
		 function(Filmeet, UrlCatalog, Keys){
	/*
	 * Creating Filmeet.Candidate class based on Ember.Object
	 */
	Filmeet.Candidate = Ember.Object.extend({
		/** Meeting sid */
		meetingSid: null,
		/** Film sid */
		filmSid: null,
		/** Film name */
		name:null,
		/** Points that has this film candidate */
		points: null
	});
	/*
	 * Reopening class for coding static properties and functions
	 */
	Filmeet.Candidate.reopenClass({
		getRankingFromMeeting: function(meetingSid){
			var ranking = [];
			
			$.ajax({
				type: 'GET',
				cache: false,
				url: UrlCatalog.get('getRankingFilms'),
				data: {'meetingSid': meetingSid, 'hash': localStorage.getItem(Keys.authorizationHash)},
				dataType:'json',
				success: function(data){
					data.forEach(function(candidate){
						ranking.addObject(Filmeet.Candidate.create({
							meetingSid: meetingSid,
							filmSid: candidate.a.sid,
							name: candidate.a.name,
							points: candidate.b
						}));
					});
				}
			});
			
			return ranking;
		}
	});
});