/**
 * FilmsDirectoryRoute.
 * @author Alejandro Arnáiz González, deathnew[at]gmail.com
 * @author Diego Crenes Carrera, dcrenes[at]gmail.com
 */

define('routes/films/filmsdirectoryroute',
		['app',
		 'utils/transitionutils',
		 'ember',
		 'views/films/directory/filmsdirectoryview',
		 'controllers/films/directory/filmsdirectorycontroller',
		 'models/film/film'],
		 function(Filmeet, TransitionUtils){
	Filmeet.FilmsDirectoryRoute = Ember.Route.extend({
		activate: function(){
			TransitionUtils.setContext(this);
			document.addEventListener('backbutton', TransitionUtils.goHome, false);
		},
		deactivate: function(){
			TransitionUtils.setContext(this);
			document.removeEventListener('backbutton', TransitionUtils.goHome);
		},
		setupController: function(controller, model){
			controller.set('searchText', null);
			controller.set('notGotIt', false);
			controller.set('content', Filmeet.Film.search(controller.get('searchText'), controller.get('notGotIt')));
		}
	});
});